
dnl Detect/download a jar file.
dnl
dnl @param $1 The environment variable name to fill out.
dnl @param $2 The human readable name for the jar, also used for the --with
dnl option name.
dnl @param $3 The description of the jar, used in the help message.
dnl @param $4 The file name for the jar.
dnl @param $5 URL to download the jar from.
dnl @param $6 Postprocessing for downloaded jars.

AC_DEFUN([NC_JAR],[
AC_MSG_CHECKING([for $2 jar file])
AC_ARG_WITH($2,
            AC_HELP_STRING([--with-$2], $3),
	    [
AC_MSG_RESULT([given on command line: $withval])
AC_SUBST($1, $withval)
NC_CLASSPATH="${NC_CLASSPATH}:$withval"
],
	    [
if test -f $srcdir/lib/$4; then
    jar_file=$abssrcdir/lib/$4
elif test -f ./$4; then
    jar_file=`pwd`/$4
else
    AC_MSG_RESULT([not found])
    if test x"$WGET" != x"" -a test x"$5" != x""; then
	AC_MSG_CHECKING([website for $2 jar file])
	$WGET -N $5 > .wget.out 2>&1
	if test $? -ne 0; then
	    download_out=`cat .wget.out`
	    AC_ERROR([Error while downloading files: $download_out])
	fi
	$6 # Postprocessing...
    else
	AC_ERROR([cannot continue without the $2 jar file.  You will need to download it separately from $5 and place it in $srcdir/lib.])
    fi
    jar_file=$abssrcdir/lib/$4
fi
AC_MSG_RESULT([found in: $jar_file])
AC_SUBST($1, $jar_file)
NC_CLASSPATH="${NC_CLASSPATH}:$jar_file"
])
])
