/*
 * AboutController.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

package net.emulab.netlab.client;

/**
 * Controller for the about box.
 */
public class AboutController extends ControllerBase {
	/**
	 * Construct an AboutController with the given value.
	 * 
	 * @param netbuild
	 *            The NetlabClient instance this controller is attached to.
	 */
	public AboutController(NetlabClient netlab) {
		super(netlab);
	}

	/**
	 * The "ok" button was clicked, close the window.
	 */
	public void ok() {
		if (this.netlab.getParent(this.view) != null)
			this.netlab.remove(this.view);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "AboutController[" + super.toString() + "]";
	}
}
