/*
 * Controller.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

package net.emulab.netlab.client;

import java.awt.Color;

public interface Controller {
	String ALLOWED_LOWER_CASE = "abcdefghijklmnopqrstuvwxyz";

	String ALLOWED_UPPER_CASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	String ALLOWED_NUMBER = "0123456789";

	String ALLOWED_FORMATTED_NUMBER = "," + ALLOWED_NUMBER;

	String ALLOWED_DECIMAL_NUMBER = "." + ALLOWED_NUMBER;

	String ALLOWED_BW_NUMBER = " kKmMgGbps" + ALLOWED_DECIMAL_NUMBER;

	String ALLOWED_USER_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-_";

	String ALLOWED_DNS_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-";

	String ALLOWED_FQN_FRIENDLY = ALLOWED_DNS_FRIENDLY + ".";

	String ALLOWED_PATH_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-./_=@%+";

	String ALLOWED_URL_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-.:/";

	String ALLOWED_OSID_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-+._";

	String ALLOWED_QUEUE_FRIENDLY = ALLOWED_LOWER_CASE + ALLOWED_UPPER_CASE
			+ ALLOWED_NUMBER + "-_";

	Color COLOR_LIGHT = new Color(0xf6f6f6);

	Color COLOR_DARK = new Color(0xd6d6d6);

	void showView(Object component) throws Exception;

	Controller setView(Object view);

	Object getView();

	Controller triggeredBy(Object component) throws Exception;

	Controller modelChanged(Object component);
}
