/*
 * Created on Oct 29, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.netlab.client;

import java.lang.reflect.Constructor;
import java.util.Hashtable;
import java.util.List;

import thinlet.Thinlet;

public class ControllerManager {

	private final Thinlet nc;
	private final Hashtable controllers = new Hashtable();

	public ControllerManager(Thinlet nc) {
		this.nc = nc;
	}

	public Controller getController(String name) throws Exception {
		Controller retval;

		if ((retval = (Controller) this.controllers.get(name)) == null) {
			Constructor constructor;
			Class cc;

			cc = Class.forName(name);
			constructor = cc.getConstructor(new Class[] { this.nc.getClass() });
			retval = (Controller)constructor.newInstance(new Object[] { this.nc });

			if (!(retval instanceof ElementController))
				this.controllers.put(name, retval);
		}
		
		return retval;
	}

	public void showView(Object sender) throws Exception {
		Object controllerObject, component;
		Controller controller;
		Object view;

		if (sender instanceof List)
			component = ((List) sender).get(0);
		else
			component = sender;
		controllerObject = this.nc.getProperty(component, "controller");
		if (controllerObject instanceof String) {
			if ((controller = (Controller) this.controllers.get(controllerObject)) == null) {
				String viewFileName;

				controller = this.getController((String)controllerObject);

				if ((viewFileName = (String) this.nc.
						getProperty(component, "view")) != null) {
					view = this.nc.parse(viewFileName, controller);
					controller.setView(view);
				}
			}
			
			this.nc.putProperty(component, "controller", controller);
		} else {
			controller = (Controller) controllerObject;
		}

		controller.triggeredBy(sender);
	}
}
