/*
 * ExperimentParameters.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

package net.emulab.netlab.client;

import java.util.Hashtable;

public class ExperimentParameters extends Hashtable {
	/**
	 * Unique identifier for serialization.
	 */
	static final long serialVersionUID = 8171193346169423215L;

	public ExperimentParameters() {
	}

	public String getProject() {
		return (String) this.get("proj");
	}

	public ExperimentParameters setProject(String proj) {
		this.put("proj", proj);
		return this;
	}

	public String getName() {
		return (String) this.get("exp");
	}

	public ExperimentParameters setName(String exp) {
		this.put("exp", exp);
		return this;
	}

	public ExperimentParameters setNSFileString(String nsfilestr) {
		this.put("nsfilestr", nsfilestr);
		return this;
	}

	public ExperimentParameters setGroup(String group) {
		this.put("group", group);
		return this;
	}

	public ExperimentParameters setBatch(boolean batch) {
		this.put("batch", Boolean.valueOf(batch));
		return this;
	}

	public ExperimentParameters setDescription(String description) {
		this.put("description", description);
		return this;
	}

	public ExperimentParameters setIdleSwap(int idleSwap) {
		this.put("idleswap", new Integer(idleSwap));
		return this;
	}

	public ExperimentParameters setNoIdleSwapReason(String reason) {
		this.put("noidleswap_reason", reason);
		return this;
	}

	public ExperimentParameters setMaxDuration(int maxDuration) {
		this.put("max_duration", new Integer(maxDuration));
		return this;
	}

	public ExperimentParameters setNoSwapIn(boolean noswapin) {
		this.put("noswapin", Boolean.valueOf(noswapin));
		return this;
	}

	public ExperimentParameters setWait(boolean wait) {
		this.put("wait", Boolean.valueOf(wait));
		return this;
	}

	public String toString() {
		return "ExperimentParameters[" + super.toString() + "]";
	}
}
