/*
 * InterfacePropertiesController.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

package net.emulab.netlab.client;

import net.emulab.ns.NSInterface;
import net.emulab.ns.NSObject;
import thinlet.NumberFormatter;
import thinlet.SizeFormatter;

public class InterfacePropertiesController extends PropertiesController {
	public static final IPv4AddressFormatter IPV4_FORMATTER = new IPv4AddressFormatter();

	public static final NumberFormatter BW_FORMATTER = new SizeFormatter("",
			"bps").setMinimum(0.1).setMaximum(NSInterface.MAX_BANDWIDTH)
			.setEmpty(new Long(-1));

	public static final NumberFormatter LATENCY_FORMATTER = new NumberFormatter()
			.setMinimum(0.0).setEmpty(new Double(-1.0));

	public static final NumberFormatter LOSS_RATE_FORMATTER = new NumberFormatter()
			.setMinimum(0.0).setMaximum(1.0).setEmpty(new Double(-1.0));

	public InterfacePropertiesController(NetlabClient netbuild) {
		super(netbuild);
		
		this.setObjectClass(NSInterface.class);

		this.vis.put("ips", Boolean.FALSE);
		this.vis.put("pipe", Boolean.TRUE);
	}

	public void setName(String name) {
	}

	public String getName() {
		return "";
	}
	
	public void setNSObject(NSObject nso) {
		super.setNSObject(nso);
		
		if (nso == null)
			this.tkv.setKeyValue(this, "vis.ips", false);
	}

	public String toString() {
		return "InterfacePropertiesController[" + super.toString() + "]";
	}
}
