/*
 * ListController.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package net.emulab.netlab.client;

public class ListController
    extends ControllerBase
{    
    public ListController(NetlabClient netbuild)
    {
	super(netbuild);
    }

    protected void setCellValue(Object row, String cellName, String value)
    {
	Object cell;

	cell = this.netlab.find(row, cellName);
	this.netlab.setString(cell, "text", value);
    }
    
    protected String getCellValue(Object row, String cellName)
    {
	String retval;
	Object cell;

	cell = this.netlab.find(row, cellName);
	retval = this.netlab.getString(cell, "text");
	return retval;
    }

    protected Object addCell(Object row, String cellName, String cellValue)
    {
	Object retval;
	
	retval = this.netlab.create("cell");
	this.netlab.setString(retval, "name", cellName);
	this.netlab.setString(retval, "text", cellValue);
	this.netlab.add(row, retval);
	return retval;
    }

    public String toString()
    {
	return "ListController["
	    + super.toString()
	    + "]";
    }
}
