/*
 * Created on Feb 7, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package net.emulab.netlab.client;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

import net.emulab.util.ServerProperties;

public class LogController extends ControllerBase {

	public static final String MODIFY_MESSAGE =
		"If it succeeds, you can click on the link to go "
		+ "to the experiment page.  If it fails, you should close this dialog "
		+ "and attempt to correct the configuration.";
	
	public Object logOutput;
	public Object expLink;
	public String pid;
	public String eid;
	public String pideid;
	public InputStream is;
	public Thread reader;
	public boolean inProgress = false;
	
	public LogController(NetlabClient netlab) {
		super(netlab);
	}

	public Controller triggeredBy(Object component) throws Exception {
		super.triggeredBy(component);

		ServerProperties sp;
		final URL url;
		
		if (this.reader != null) {
			System.out.println("wait");
			synchronized(this.reader) {
				while (this.is == null)
					this.reader.wait();
			}
			System.out.println("wait done");
			try { this.is.close(); }
			catch (IOException e) {}
			this.is = null;
			System.out.println("join");
			this.reader.join();
			System.out.println("join done");
			this.reader = null;
		}
		
		this.tkv.setKeyValue(this, "inProgress", true);
		this.tkv.setKeyValue(this, "pid", this.netlab.getProperty(component, "pid"));
		this.tkv.setKeyValue(this, "eid", this.netlab.getProperty(component, "eid"));
		this.tkv.setKeyValue(this, "pideid", this.pid + "/" + this.eid);
		
		this.netlab.putProperty(this.expLink, "aref",
				"showexp.php3?pid=" + this.pid + "&eid=" + this.eid);

		sp = (ServerProperties)this.netlab.getPoolValue("server");
		
		url = sp.getURL("spewlogfile.php3", new String[] {
				"pid", this.pid,
				"eid", this.eid
		});
		
		this.netlab.setString(this.logOutput, "text", "");
		this.reader = new Thread() {
			public void run() {
				try {
					byte buffer[] = new byte[1024];
					URLConnection uc;
					String text = "";
					int rc;

					System.out.println("read");
					synchronized(this) {
						uc = url.openConnection();
						is = uc.getInputStream();
						
						this.notifyAll();
					}
					while ((rc = is.read(buffer)) > 0) {
						String seg = new String(buffer, 0, rc);
						
						if ("".equals(text)) {
							seg = seg.replaceFirst("[ \n]+", "");
						}
						text += seg;
						netlab.setString(logOutput, "text", text);
						netlab.setInteger(logOutput, "start", text.length());
						netlab.setInteger(logOutput, "end", text.length());
					}
					System.out.println("read done");
				}
				catch (IOException e) {
					e.printStackTrace();
				}
				tkv.setKeyValue(LogController.this, "inProgress", false);
			}
		};
		this.reader.start();
		
		return this;
	}
	
	/**
	 * The "ok" button was clicked, close the window.
	 */
	public void ok() {
		if (this.netlab.getParent(this.view) != null)
			this.netlab.remove(this.view);
	}

}
