/*
 * Created on Oct 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.netlab.client;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;

import thinlet.Thinlet;
import thinlet.ThinletEntryException;
import thinlet.ThinletKeyValue;

public class NoticeController {
	
	public final NetlabClient nc;
	private final ThinletKeyValue tkv;
	
	private final Object dialog;
	
	public Object errorWhat;
	public Object errorFix;
	public Object errorOk;
	public Object errorDetails;
	
	public String whatHappened = "";
	public int whatRows = 1;
	public String whatToDo = "";
	public int todoRows = 1;
	public String moreDetail = "";
	public boolean errorDetailsVisible = false;

	public NoticeController(NetlabClient nc) throws IOException {
		this.nc = nc;
		this.tkv = nc.getNamespace();
		
		this.dialog = this.nc.parse("errordialog.xml", this);
		
		this.tkv.addKeyDependency(this, "hasDetails", "moreDetail");
	}
	
	public boolean hasDetails() {
		return (this.moreDetail.length() > 0);
	}

	protected String traceToString(Throwable th) {
		ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
		PrintStream ps = new PrintStream(baos);
		String retval;

		th.printStackTrace(ps);
		retval = baos.toString().replaceAll("\t", "        ");
		return retval;
	}

	public void showDialog(Throwable th) {
		String msg = th.getMessage();
		
		if (msg == null || "".equals(msg)) {
			msg = "Internal Error";
		}
		this.tkv.setKeyValue(this, "whatHappened", msg);
		this.tkv.setKeyValue(this, "whatRows", Thinlet.computeRowCount(msg, 30));
		if (th instanceof ThinletEntryException) {
			ThinletEntryException tee = (ThinletEntryException)th;
			
			this.tkv.setKeyValue(this, "whatToDo", tee.getExplanation());
			this.tkv.setKeyValue(this, "todoRows", Thinlet.computeRowCount(tee.getExplanation(), 30));
			this.tkv.setKeyValue(this, "moreDetail", "");
		}
		else {
			this.tkv.setKeyValue(this, "whatToDo", "");
			this.tkv.setKeyValue(this, "todoRows", 1);
			this.tkv.setKeyValue(this, "moreDetail", this.traceToString(th));
		}
		this.nc.add(this.dialog);
	}

	public void showDialog(String msg, String exp) {
		this.tkv.setKeyValue(this, "whatHappened", msg);
		this.tkv.setKeyValue(this, "whatRows", Thinlet.computeRowCount(msg, 30));
		if (exp != null) {
			this.tkv.setKeyValue(this, "whatToDo", exp);
			this.tkv.setKeyValue(this, "todoRows", Thinlet.computeRowCount(exp, 30));
		}
		else {
			this.tkv.setKeyValue(this, "whatToDo", "");
			this.tkv.setKeyValue(this, "todoRows", 1);
		}
		this.tkv.setKeyValue(this, "moreDetail", "");
		this.nc.add(this.dialog);
	}
	
	public void showDialog(String msg) {
		this.showDialog(msg, null);
	}

	public void closeDialog(Object sender) {
		this.nc.remove(this.dialog);
	}
}
