/*
 * AboutController.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

package net.emulab.netlab.client;


/**
 * Controller for the about box.
 */
public class QuickHelpController extends ControllerBase {
	public int docid;
	
	/**
	 * Construct an AboutController with the given value.
	 * 
	 * @param netbuild
	 *            The NetlabClient instance this controller is attached to.
	 */
	public QuickHelpController(NetlabClient netlab) {
		super(netlab);
	}

	public Controller triggeredBy(Object component) throws Exception {
		super.triggeredBy(component);
		
		this.tkv.setKeyValue(this,
				"docid",
				Integer.valueOf((String)this.netlab.getProperty(component, "docid")));
		
		return this;
	}

	/**
	 * The "ok" button was clicked, close the window.
	 */
	public void ok() {
		this.netlab.remove(this.view);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "QuickHelpController[" + super.toString() + "]";
	}
}
