/*
 * TarFileController.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package net.emulab.netlab.client;

import java.util.TreeSet;

public class TarFileController implements Controller {
	private static final String DEFAULT_LAN_NAME = "lan";

	protected final NetlabClient netbuild;

	public TarFileController(NetlabClient netbuild) {
		this.netbuild = netbuild;
	}

	public void showView(Object component) throws Exception {
		this.netbuild.showView(component);
	}

	public Controller setView(Object view) {
		return this;
	}

	public Controller modelChanged(Object component) {
		return this;
	}

	public Controller triggeredBy(Object component) throws Exception {
		String name;

		if (this.netbuild.getProperty(component, "model") == null) {
			this.netbuild.putProperty(component, "model", new TreeSet());
		}
		this.netbuild.setBoolean(component, "draggable", true);
		this.netbuild.setMethod(component, "action", "showView(this)",
				component, this);
		this.netbuild.putProperty(component, "nsocontroller", this);
		this.netbuild.putProperty(component, "view", "tarfilesdialog.xml");
		this.netbuild.putProperty(component, "controller",
				"net.emulab.netlab.client.TarFileListController");

		this.showView(component);
		this.netbuild.requestFocus(component);

		return this;
	}

	public String toString() {
		return "TarFileController[" + "]";
	}
}
