/*
 * Created on Oct 29, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.netlab.client;

import java.util.ArrayList;

import net.emulab.ns.NSAggregate;
import net.emulab.ns.NSNode;
import net.emulab.ns.NSObject;
import net.emulab.ns.NSTopology;
import net.emulab.ns.Namer;
import thinlet.ObjectController;
import thinlet.ThinletKeyValue;
import thinlet.ThinletKeyValueObserver;

public class TopologyController extends ObjectController {

	private NSTopology nst;
	private Namer namer;
	private int objectCount = 0;
	protected Object selection = null;
	
	public TopologyController(NetlabClient nc) {
		super(nc, new NSTopology());
		
		this.objectClass = null;
		this.nst = (NSTopology)this.content;
		this.namer = this.nst.getNamer();
	}

	public boolean hasNodes() {
		return (this.nst.getNodes().size() > 0);
	}

	public void setContent(Object content) {
		super.setContent(content);
		
		this.nst = (NSTopology)content;
		this.namer = this.nst.getNamer();
	}
	
	public void setSelection(Object selection) {
		this.selection = selection;
	}
	
	public Object selection() {
		return this.selection;
	}
	
	public Namer getNamer() {
		return this.namer;
	}
	
	public int incrementObjectCount() {
		return this.objectCount++;
	}
	
	public void clear() {
		this.tkv.setKeyValue(this, "content", new NSTopology());
		this.namer.clear();
	}

	public void addNSObject(NSObject nso) {
		this.nst.add(nso);
		if (nso instanceof NSNode) {
			this.tkv.notifyKeyValue(this, "content.nodes", ThinletKeyValue.CHANGE_SETTING, null, new ArrayList(this.nst.getNodes()));
			this.tkv.notifyKeyValue(this, "hasNodes", ThinletKeyValue.CHANGE_SETTING, null, Boolean.TRUE);
			this.tkv.observeKeyValue(nso, "", new ThinletKeyValueObserver() {
				public void observedKeyValue(Object obj, String keyPath, int flags, Object oldValue, Object newValue) {
					int index = nst.getNodes().indexOf(obj);
					tkv.notifyKeyValue(TopologyController.this,
							"content.nodes", ThinletKeyValue.CHANGE_REPLACE, null, new int[] { index, index + 1 });
				}
			});
		}
	}

	public synchronized void replaceNSObject(NSObject nsoOld, NSObject nsoNew) {
		this.nst.remove(nsoOld);
		this.nst.add(nsoNew);
	}

	public void removeNSObject(NSObject nso) {
		this.nst.remove(nso);
		if (nso instanceof NSNode) {
			/* XXX remove observers */
			this.tkv.notifyKeyValue(this, "content.nodes", ThinletKeyValue.CHANGE_SETTING, null, new ArrayList(this.nst.getNodes()));
			this.tkv.notifyKeyValue(this, "hasNodes", ThinletKeyValue.CHANGE_SETTING, null, Boolean.valueOf(this.hasNodes()));
		}
	}

	public void addAggregate(NSAggregate nsa) {
		this.nst.addAggregate(nsa);
	}

	public void removeAggregate(NSAggregate nsa) {
		this.nst.removeAggregate(nsa);
	}

	public NSTopology getNSTopology() {
		return this.nst;
	}
}
