/*
 * Created on Nov 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.netlab.client;

import java.util.Hashtable;

import net.emulab.ns.LinkTraffic;
import net.emulab.ns.NSAggregate;
import net.emulab.ns.NSObject;
import thinlet.ArrayController;

public class TrafficArrayController extends ArrayController {
	protected static final Hashtable DEFAULT_ATTRIBUTES = new Hashtable();

	protected static final String DEFAULT_TYPE = "UDP";

	private static final long DEFAULT_PACKET_SIZE = 500;

	private static final long DEFAULT_RATE = 4000;

	private static final double DEFAULT_INTERVAL = (DEFAULT_PACKET_SIZE * 8)
			/ DEFAULT_RATE;
	
	static {
		DEFAULT_ATTRIBUTES.put("rate_", new Long(DEFAULT_RATE));
		DEFAULT_ATTRIBUTES.put("packetSize_", new Long(DEFAULT_PACKET_SIZE));
		DEFAULT_ATTRIBUTES.put("interval_", new Double(DEFAULT_INTERVAL));
	}
	
	protected final NetlabClient netlab;

	protected final UniqueNameFormatter formatter;
	
	public boolean rateLock;

	public boolean packetSizeLock = true;

	public boolean intervalLock;

	public TrafficArrayController(NetlabClient netlab, UniqueNameFormatter formatter) {
		super(netlab);
		
		this.formatter = formatter;

		this.netlab = netlab;

		this.tkv.addKeyDependency(this, "leftToRight", "selection");
		this.tkv.addKeyDependency(this, "rightToLeft", "selection");
	}

	public void removeObject(Object value) {
		TopologyController tc = this.netlab.getTopologyController();
		NSObject nso = (NSObject)value;
		
		super.removeObject(value);

		tc.removeAggregate((NSAggregate)value);
		tc.getNamer().remove(nso.getName());
	}

	public void setSelection(Object selection) {
		super.setSelection(selection);
		
		if (selection instanceof NSAggregate) {
			this.formatter.setNSObject((NSObject)selection);
		}
		else {
			this.formatter.setNSObject(null);
		}
	}

	public String leftToRight() {
		String retval = "";
		
		if (this.selection instanceof LinkTraffic) {
			LinkTraffic lt = (LinkTraffic)this.selection;
			
			retval = (lt.getLeft().getName() + " to "
					+ lt.getRight().getName());
		}
		
		return retval;
	}

	public String rightToLeft() {
		String retval = "";
		
		if (this.selection instanceof LinkTraffic) {
			LinkTraffic lt = (LinkTraffic)this.selection;
			
			retval = (lt.getRight().getName() + " to "
					+ lt.getLeft().getName());
		}
		
		return retval;
	}
	
	public String toString() {
		return "TrafficArrayController[" + super.toString() + "]";
	}
}