/*
 * Created on Nov 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.netlab.client;

import thinlet.ThinletController;
import thinlet.ThinletKeyValue;
import thinlet.ThinletKeyValueObserver;

public class TrafficAttrObserver implements ThinletKeyValueObserver {
	private final TrafficArrayController controller;
	private final ThinletKeyValue tkv;
	
	public TrafficAttrObserver(TrafficArrayController controller, ThinletKeyValue tkv) {
		this.controller = controller;
		this.tkv = tkv;
	}

	public void observedKeyValue(Object obj, String keyPath,
			int flags, Object oldValue, Object newValue) {
		if ((tkv.getKeyValue(obj, "selection") != ThinletController.NO_SELECTION)
				&& keyPath.startsWith("selection.attributes")) {
			double rate, packetSize, newRate, newPacketSize;
			double interval, newInterval;
	
			rate = newRate = tkv.getKeyValueAsDouble(obj,
					"selection.attributes.rate_");
			packetSize = newPacketSize = tkv
					.getKeyValueAsDouble(obj,
							"selection.attributes.packetSize_");
			interval = newInterval = tkv.getKeyValueAsDouble(
					obj, "selection.attributes.interval_");
			if (keyPath.endsWith(".rate_")) {
				if (controller.packetSizeLock)
					newInterval = packetSize * 8.0 / rate;
				else
					newPacketSize = interval * rate / 8.0;
			} else if (keyPath.endsWith(".interval_")) {
				if (controller.rateLock)
					newPacketSize = interval * rate / 8.0;
				else
					newRate = packetSize * 8.0 / interval;
			} else if (keyPath.endsWith(".packetSize_")) {
				if (controller.rateLock)
					newInterval = packetSize * 8.0 / rate;
				else
					newRate = packetSize * 8.0 / interval;
			}
			if (newInterval != interval) {
				tkv.setKeyValue(obj,
						"selection.attributes.interval_",
						newInterval);
			}
			if (newRate != rate) {
				tkv.setKeyValue(obj,
						"selection.attributes.rate_",
						(long) newRate);
			}
			if (newPacketSize != packetSize) {
				tkv.setKeyValue(obj,
						"selection.attributes.packetSize_",
						(long) newPacketSize);
			}
		}
	}
}