/*
 * EmulabUserInfo.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package net.emulab.netlab.client.emulab;

import java.io.Serializable;
import java.util.Hashtable;

/**
 * Container for information about the user's Emulab account.
 */
public class EmulabUserInfo implements Serializable {
	/**
	 * The user's project/group membership. The table is indexed by project name
	 * that refer to a Vector of group names.
	 */
	protected Hashtable membership;

	/**
	 * Construct an EmulabUserInfo object with the default values.
	 */
	public EmulabUserInfo() {
	}

	/**
	 * @param membership
	 *            The user's project/group membership. The table is indexed by
	 *            project name that refer to a Vector of group names.
	 * @return this
	 */
	public EmulabUserInfo setMembership(Hashtable membership) {
		this.membership = membership;
		return this;
	}

	/**
	 * @return The user's project/group membership. The table is indexed by
	 *         project name that refer to a Vector of group names.
	 */
	public Hashtable getMembership() {
		return this.membership;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "EmulabUserInfo[projectList=" + this.membership + "]";
	}
}
