/*
 * Created on Nov 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package net.emulab.ns;

import java.util.Hashtable;

public class NSEvent {
	public static final NSObject NS_SEQUENCE = new NSBase();
	
	public static final int OBJECT_TYPE_LINK = 1;
	public static final int OBJECT_TYPE_TRAFGEN = 2;
	public static final int OBJECT_TYPE_TIME = 3;
	public static final int OBJECT_TYPE_PROGRAM = 4;
	public static final int OBJECT_TYPE_SIMULATOR = 6;
	public static final int OBJECT_TYPE_LINKTEST = 7;
	public static final int OBJECT_TYPE_NODE = 10;
	public static final int OBJECT_TYPE_SEQUENCE = 11;
	public static final int OBJECT_TYPE_TIMELINE = 12;
	public static final int OBJECT_TYPE_CONSOLE = 13;
	public static final int OBJECT_TYPE_LINKTRACE = 15;

	public static final int EVENT_TYPE_REBOOT = 0;
	public static final int EVENT_TYPE_START = 1;
	public static final int EVENT_TYPE_STOP = 2;
	public static final int EVENT_TYPE_UP = 3;
	public static final int EVENT_TYPE_DOWN = 4;
	public static final int EVENT_TYPE_UPDATE = 5;
	public static final int EVENT_TYPE_MODIFY = 6;
	public static final int EVENT_TYPE_SET = 7;
	public static final int EVENT_TYPE_TIME = 8;
	public static final int EVENT_TYPE_RESET = 9;
	public static final int EVENT_TYPE_KILL = 10;
	public static final int EVENT_TYPE_HALT = 11;
	public static final int EVENT_TYPE_SWAPOUT = 12;
	public static final int EVENT_TYPE_REPORT = 14;
	public static final int EVENT_TYPE_ALERT = 15;
	public static final int EVENT_TYPE_SETDEST = 16;
	public static final int EVENT_TYPE_COMPLETE = 17;
	public static final int EVENT_TYPE_MESSAGE = 18;
	public static final int EVENT_TYPE_LOG = 19;
	public static final int EVENT_TYPE_RUN = 20;
	public static final int EVENT_TYPE_SNAPSHOT = 21;
	public static final int EVENT_TYPE_RELOAD = 22;
	
	private double time;
	
	private int objectType;
	
	private int eventType;
	
	private NSObject nso;
	
	private NSObject parent;
	
	private Hashtable arguments = new Hashtable();
	
	public NSEvent() {
	}

	public Hashtable getArguments() {
		return arguments;
	}

	public void setArguments(Hashtable arguments) {
		this.arguments = arguments;
	}
	
	public void parseArguments(String args) {
		final int STATE_KEY = 0;
		final int STATE_VALUE = 1;
		
		int index, len, start = 0, state = STATE_KEY;
		boolean squotes = false, dquotes = false;
		String key = null;
		int cquotes = 0;
		
		len = args.length();
		for (index = 0; index < len; index++) {
			char ch = args.charAt(index);
			
			switch (state) {
			case STATE_KEY:
				switch (ch) {
				case ' ':
				case '\t':
					if (start < index) {
						this.arguments.put(args.substring(start, index), "");
					}
					start = index + 1;
					break;
				case '=':
					state = STATE_VALUE;
					key = args.substring(start, index);
					start = index + 1;
					break;
				}
				break;
			case STATE_VALUE:
				switch (ch) {
				case ' ':
				case '\t':
					if (cquotes == 0 && !squotes && !dquotes) {
						this.arguments.put(key, args.substring(start, index));
						state = STATE_KEY;
						start = index + 1;
					}
					break;
				case '\'':
					squotes = !squotes;
					break;
				case '\"':
					dquotes = !dquotes;
					break;
				case '{':
					cquotes += 1;
					if (cquotes == 1) {
						start += 1;
					}
					break;
				case '}':
					if (cquotes == 1) {
						this.arguments.put(key, args.substring(start, index));
						state = STATE_KEY;
						start = index + 1;
					}
					cquotes -= 1;
					break;
				}
				break;
			}
		}
		if (start < index) {
			if (key != null)
				this.arguments.put(key, args.substring(start, index));
			else
				this.arguments.put(args.substring(start, index), "");
		}
	}

	public int getEventType() {
		return eventType;
	}

	public void setEventType(int eventType) {
		this.eventType = eventType;
	}

	public int getObjectType() {
		return objectType;
	}

	public void setObjectType(int objectType) {
		this.objectType = objectType;
	}

	public NSObject getParent() {
		return parent;
	}

	public void setParent(NSObject parent) {
		this.parent = parent;
	}

	public double getTime() {
		return time;
	}

	public void setTime(double time) {
		this.time = time;
	}

	public NSObject getNSObject() {
		return this.nso;
	}

	public void setNSObject(NSObject nso) {
		this.nso = nso;
	}
}
