/*
 * Created on Nov 8, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.emulab.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

public class FileDiff {
	public static void main(String[] args) throws IOException {
		System.out.println(diff(
				"set ns [new Simulator]\n"
				+ "source tb_compat.tcl\n"
				+ "\n"
				+ "$ns run\n",
				
				"set ns [new Simulator]\n"
				+ "$ns run\n"
				+ "# foobar\n"));
	}
	
	public static int indexOf(List list, String type, String line) {
		int lpc, size, retval = -1;
		
		size = list.size();
		for (lpc = 0; lpc < size; lpc++) {
			FileDiff fd = (FileDiff) list.get(lpc);
			
			if (fd.getType().equals(type) && fd.getLine().equals(line)) {
				retval = lpc;
				break;
			}
		}
		
		return retval;
	}
	
	private final int number;
	private String type;
	private final String line;
	
	public FileDiff(int number, String type, String line) {
		this.number = number + 1;
		this.type = type;
		this.line = line;
	}
	
	public int getNumber() {
		return this.number;
	}
	
	public void setType(String type) {
		this.type = type;
	}
	
	public String getType() {
		return this.type;
	}
	
	public String getLine() {
		return this.line;
	}
	
	public static List diff(String s0, String s1) {
		List retval = new ArrayList();
		int MAX = 10000;
		String[] x = new String[MAX]; // lines in first file
		String[] y = new String[MAX]; // lines in second file
		int M = 0; // number of lines of first file
		int N = 0; // number of lines of second file

		// read in input from two files
		BufferedReader in0 = new BufferedReader(new StringReader(s0));
		BufferedReader in1 = new BufferedReader(new StringReader(s1));
		String line;
		try {
			while ((line = in0.readLine()) != null)
				x[M++] = line;
			while ((line = in1.readLine()) != null)
				y[N++] = line;
		}
		catch (IOException e) {
			throw new InternalError();
		}

		// opt[i][j] = length of LCS of x[i..M] and y[j..N]
		int[][] opt = new int[M + 1][N + 1];

		// compute length of LCS and all subproblems via dynamic programming
		for (int i = M - 1; i >= 0; i--) {
			for (int j = N - 1; j >= 0; j--) {
				if (x[i].equals(y[j]))
					opt[i][j] = opt[i + 1][j + 1] + 1;
				else
					opt[i][j] = Math.max(opt[i + 1][j], opt[i][j + 1]);
			}
		}

		// recover LCS itself and print out non-matching lines to standard
		// output
		int i = 0, j = 0;
		while (i < M && j < N) {
			if (x[i].equals(y[j])) {
				retval.add(new FileDiff(j, "", y[j]));
				i++;
				j++;
			} else if (opt[i + 1][j] >= opt[i][j + 1])
				retval.add(new FileDiff(i, "-", x[i++]));
			else
				retval.add(new FileDiff(j, "+", y[j++]));
		}

		// dump out one remainder of one string if the other is exhausted
		while (i < M || j < N) {
			if (i == M)
				retval.add(new FileDiff(j, "+", y[j++]));
			else if (j == N)
				retval.add(new FileDiff(i, "-", x[i++]));
		}
		
		return retval;
	}
}
