package net.emulab.util;

/**
 * Interface for classes that can halt the progress of some operation.
 */
public interface ProgressHalter {
	/**
	 * Callback used to halt progress. For example, an InputStream that
	 * implements this interface could throw an exception or return -1 on any
	 * reads that occur after this method was called.
	 */
	void haltProgress();
}
