import java.util.*;

import thinlet.*;

public class autowire {
	public static final ThinletKeyValue tkv = new ThinletKeyValue();

	public static final Hashtable pool = new Hashtable() {
		public int hashCode() {
			return System.identityHashCode(this);
		}

		public boolean equals(Object obj) {
			return (obj == this);
		}
	};

	public static class MailAddress {
		private String userName;

		private String domainName;

		public MailAddress() {
			tkv.observeKeyValue(pool, "user", ThinletKeyValue.CHANGE_SETTING,
					this, "user");
			tkv.observeKeyValue(pool, "system-user",
					ThinletKeyValue.CHANGE_SETTING, this, "user");
			tkv.observeKeyValue(pool, "domain", ThinletKeyValue.CHANGE_SETTING,
					this, "domain");
		}

		public void setUser(String newValue) {
			System.out.println("set user");
			this.userName = newValue;
		}

		public void setDomain(String newValue) {
			this.domainName = newValue;
		}

		public String toString() {
			return this.userName + "@" + this.domainName;
		}
	}

	public static class MailMessage {
		private MailAddress fromAddress;

		public MailMessage(ObjectFactory of) {
			of.wirePathToObjectKey("emailAddress", this, "fromAddress");
		}

		public MailMessage() {
		}

		public void setFromAddress(MailAddress address) {
			this.fromAddress = address;
		}

		public MailAddress getFromAddress() {
			return this.fromAddress;
		}

		public String toString() {
			return "MailMessage[fromAddress=" + this.fromAddress + "]";
		}
	}

	public static void main(String args[]) throws Throwable {
		ObjectFactory mmof = new ObjectFactory(tkv, pool, MailMessage.class);

		tkv.setKeyValue(pool, "domain", "cs.utah.edu");
		tkv.setKeyValue(pool, "mailMessageFactory", mmof);

		MailAddress ma = new MailAddress();

		System.out.println("before: " + ma);
		tkv.setKeyValue(pool, "user", "default");
		System.out.println("after: " + ma);

		tkv.setKeyValue(pool, "system-user", System.getProperty("user.name"));

		System.out.println("after2: " + ma);
		if (args.length > 0)
			tkv.setKeyValue(pool, "user", args[0]);
		System.out.println("after3: " + ma);

		tkv.setKeyValue(pool, "emailAddress", ma);

		MailMessage mm;

		mm = (MailMessage) tkv
				.getKeyValue(pool, "mailMessageFactory.whitehole");
		System.out.println("mm = " + mm);
	}
}
