import java.util.List;
import java.util.Arrays;
import java.util.Vector;

import thinlet.AutoFillController;
import thinlet.Thinlet;
import thinlet.FrameLauncher;
import thinlet.ArrayController;
import thinlet.NumberFormatter;
import thinlet.ThinletKeyValue;

public class bindings extends Thinlet {
	public static class element {
		public String name;

		private int age;

		public String build;

		public element(String name, int age, String build) {
			this.name = name;
			this.age = age;
			this.build = build;
		}

		public int getAge() {
			return this.age;
		}

		public void setAge(int age) {
			this.age = age;
		}

		public element() {
			this.name = "Jane Doe";
			this.age = 0;
			this.build = "";
		}
	}

	private static final List EXAMPLE_LIST = Arrays.asList(new element[] {
			new element("Veronic Mars", 16, "scrawny"),
			new element("Keith Mars", 40, "brawny"),
			new element("Wallace", 16, "thin"), });

	public static final NumberFormatter AGE_FORMATTER =
		new NumberFormatter().setMinimum(0);

	public final ArrayController ac;
	
	public final AutoFillController sc;

	public int sliderValue;

	public bindings(String args[]) throws Exception {
		this.ac = new ArrayController(this, new Vector(EXAMPLE_LIST));
		this.ac.setObjectClass(element.class);
		
		this.sc = new AutoFillController(this);
		this.sc.setObjectClass(String.class);
		
		this.tkv.observeKeyValue(this.ac, "arrangedObjects.name", 
				ThinletKeyValue.CHANGE_ANY,
				this.sc,
				"content");

		this.add(this.parse("main.xml"));
	}

	public void test(String s, int i, double d) {
		System.out.println("s=" + s + "; i=" + i + "; d=" + d);
	}
	
	public void quit() {
		System.exit(0);
	}

	public static void main(String args[]) throws Throwable {
		bindings b;

		b = new bindings(args);
		new FrameLauncher("Bindings Example", b, 300, 200);
	}
}
