import thinlet.Thinlet;
import thinlet.FrameLauncher;
import thinlet.ThinletDragInfo;
import thinlet.ThinletDragSource;
import thinlet.ThinletDragSourceBase;
import thinlet.ThinletDropDestination;
import thinlet.ThinletDropDestinationBase;

public class dragdrop extends Thinlet {
	public static final ThinletDragSource DRAG_SRC = new ThinletDragSourceBase() {
		public Object dragStart(Thinlet thinlet, Object sender) {
			Object retval = thinlet.create("togglebutton");

			thinlet.setString(retval, "text", thinlet.getString(sender, "text"));
			thinlet.setDelegate(retval, "dragsrc", DRAG_MOVE_SRC);

			return retval;
		}
	};

	public static final ThinletDragSource DRAG_MOVE_SRC = new ThinletDragSourceBase() {
		public Object dragStart(Thinlet thinlet, Object sender) {
			return sender;
		}
	};

	public static final ThinletDropDestination DROP_DST = new ThinletDropDestinationBase() {
		public boolean draggingEntered(Thinlet thinlet, ThinletDragInfo tdi) {
			thinlet.setBoolean(tdi.getDropZone(), "border", true);
			return true;
		}

		public void draggingExited(Thinlet thinlet, ThinletDragInfo tdi) {
			thinlet.setBoolean(tdi.getDropZone(), "border", false);
		}

		public boolean prepareForDrop(Thinlet thinlet, ThinletDragInfo tdi) {
			return true;
		}

		public void performDrop(Thinlet thinlet, ThinletDragInfo tdi) {
			thinlet.add(tdi.getDropZone(), tdi.getSource());
		}

		public void finishDrop(Thinlet thinlet, ThinletDragInfo tdi) {
		}
	};

	public Object msgarea;

	public dragdrop(String args[]) throws Exception {
		this.add(this.parse("main.xml"));
	}
	
	public static void main(String args[]) throws Throwable {
		dragdrop dd;

		dd = new dragdrop(args);
		new FrameLauncher("Drag and Drop Example", dd, 400, 300);
	}
}
