/*
 * Created on Jul 3, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package thinlet;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.TreeSet;

public class IntersectArrayController extends ArrayController {

	private final String keyPath;
	private List superContent;
	
	public IntersectArrayController(Thinlet thinlet, String keyPath) {
		super(thinlet);
		
		this.keyPath = keyPath;
	}

	public void setSuperContent(List sc) {
		this.superContent = sc;
		if (sc == null) {
			this.setContent(null);
		}
		else if (sc.size() == 0) {
			this.setContent(new ArrayList());
		}
		else if (sc.size() == 1) {
			this.setContent(this.tkv.getKeyValue(sc.get(0), this.keyPath));
		}
		else {
			List intersection = new ArrayList();
			List union = new ArrayList();
			List newContent = new ArrayList();
			Collection coll;
			int lpc, size;
			
			coll = (Collection)this.tkv.getKeyValue(sc.get(0), this.keyPath);
			intersection.addAll(coll);
			union.addAll(coll);
			size = sc.size();
			for (lpc = 1; lpc < size; lpc++) {
				coll = (Collection)this.tkv.getKeyValue(sc.get(lpc), this.keyPath);
				intersection.retainAll(coll);
				union.addAll(coll);
			}
			
			size = intersection.size();
			for (lpc = 0; lpc < size; lpc++) {
				Object obj = intersection.get(lpc);
				List ucp = new ArrayList();
				
				ucp.addAll(union);
				ucp.retainAll(Collections.singletonList(obj));
				newContent.add(ucp);
			}
			
			this.setContent(newContent);
		}
	}
	
	public List getSuperContent() {
		return this.superContent;
	}
	
	public void add(Object sender) throws InstantiationException, IllegalAccessException {
		if (this.superContent.size() > 1) {
			List newValue = new ArrayList();
			int lpc;
			
			for (lpc = 0; lpc < this.superContent.size(); lpc++) {
				Collection coll = (Collection)this.tkv.getKeyValue(this.superContent.get(lpc), this.keyPath);
				Object value = this.newObject();
				
				newValue.add(value);
				coll.add(value);
			}
			super.addObject(newValue);
		}
		else {
			super.addObject(this.newObject());
		}
	}
	
	public void removeObject(Object value) {
		super.removeObject(value);
		
		if (this.superContent.size() > 1) {
			int lpc;
			
			for (lpc = 0; lpc < this.superContent.size(); lpc++) {
				Collection coll = (Collection)this.tkv.getKeyValue(this.superContent.get(lpc), this.keyPath);
				
				coll.remove(value);
			}
		}
	}
}
