package thinlet;

public class MutableString implements Comparable {
	private final StringBuffer sb = new StringBuffer();

	public MutableString(String initialValue) {
		this.setValue(initialValue);
	}

	public void setValue(String value) {
		this.sb.replace(0, value.length(), value);
		this.sb.setLength(value.length());
	}

	public String getValue() {
		return this.sb.toString();
	}

	public int compareTo(Object obj) {
		String s1, s2;
		int retval;

		if (!(obj instanceof MutableString))
			throw new IllegalArgumentException("obj is not a MutableString");

		s1 = this.toString();
		s2 = this.toString();

		retval = s1.compareTo(s2);

		return retval;
	}

	public boolean equals(Object obj) {
		boolean retval = false;

		if (obj instanceof MutableString) {
			MutableString ms = (MutableString) obj;

			retval = this.sb.equals(ms.sb);
		}
		return retval;
	}

	public String toString() {
		return this.sb.toString();
	}
}
