package thinlet;

/**
 * Base class for ThinletControllers.
 */
public class ThinletControllerBase implements ThinletController {
	/**
	 * Reference to the Thinlet instance this controller is working with.
	 */
	protected Thinlet thinlet;

	/**
	 * Cached reference to the Thinlet key/value namespace.
	 */
	protected ThinletKeyValue tkv;

	/**
	 * Construct a ThinletControllerBase with the given value.
	 * 
	 * @param thinlet
	 *            Reference to the Thinlet instance this controller is working
	 *            with.
	 */
	protected ThinletControllerBase(Thinlet thinlet) {
		this.thinlet = thinlet;
		this.tkv = thinlet.getNamespace();
	}

	public String toString() {
		return "ThinletControllerBase[thinlet=" + this.thinlet + "; tkv="
		// recurse + this.tkv
				+ "]";
	}
}
