package thinlet;

/**
 * Interface for objects that wish to observe key/value changes.
 */
public interface ThinletKeyValueObserver {
	/**
	 * Callback used when a value for a key has changed.
	 * 
	 * @param obj
	 *            The object where the change took place.
	 */
	void observedKeyValue(Object obj, String keyPath, int flags,
			Object oldValue, Object newValue);
}
