/*
 * NSLanLinkTest.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

import net.emulab.ns.NSNode;
import net.emulab.ns.NSLink;
import net.emulab.ns.NSInterface;
import net.emulab.ns.UniqueName;

public class NSLanLinkTest {
	public static void main(String args[]) {
		NSInterface nsi;
		NSLink nsl;
		NSNode nsn;

		nsl = new NSLink();

		nsn = new NSNode();
		nsn.setName(new UniqueName("node"));
		nsi = new NSInterface().setNSObject(nsn);
		nsl.addMember(nsi);

		if (!nsl.isMember(nsn)) {
			System.out.println("Node is not a member?");
		}

		if (nsl.isMember(new NSNode())) {
			System.out.println("New node is a member?");
		}

		try {
			nsl.addMember(nsi);
			System.out.println("Able to add existing member?");
		} catch (IllegalArgumentException e) {
		}

		try {
			nsl.addMember(new NSInterface());
			System.out.println("Able to add incomplete member?");
		} catch (IllegalArgumentException e) {
		}

		if (!nsl.removeMember(nsn)) {
			System.out.println("Cannot remove member?");
		}

		if (nsl.isMember(nsn)) {
			System.out.println("Node is still a member?");
		}

		try {
			nsl.setNetMask("0");
			System.out.println("Bad netmask worked?");
		} catch (IllegalArgumentException e) {
		}

		System.out.println("done");
	}
}

/*
 * Expected Output: done
 */
