/*
 * NSLinkTest.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

import net.emulab.ns.NSNode;
import net.emulab.ns.NSLink;
import net.emulab.ns.NSInterface;

public class NSLinkTest
{
    public static void main(String args[])
    {
	NSLink nsl;
	
	nsl = new NSLink();

	nsl.addMember(new NSInterface().setNSObject(new NSNode()));
	nsl.addMember(new NSInterface().setNSObject(new NSNode()));

	try
	{
	    nsl.addMember(new NSInterface());
	    System.out.println("Link accepts more than two interfaces?");
	}
	catch(IllegalStateException e)
	{
	}

	if( nsl.getLeftMember() == null )
	{
	    System.out.println("Left member is null?");
	}

	if( nsl.getRightMember() == null )
	{
	    System.out.println("Right member is null?");
	}

	if( nsl.getLeftMember() == nsl.getRightMember() )
	{
	    System.out.println("Left and right members are the same?");
	}

	System.out.println("done");
    }
}

/* Expected Output:
done
*/
