/*
 * NamerTest.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

import net.emulab.ns.Namer;
import net.emulab.ns.UniqueName;

public class NamerTest
{
    public static void main(String args[])
    {
	Namer namer = new Namer();

	namer.put(new UniqueName("node2"));
	namer.put(new UniqueName("node1"));
	namer.put(new UniqueName("node5"));

	System.out.println("suggest = " + namer.suggest("node"));
	System.out.println("suggest = " + namer.suggest("node"));
	System.out.println("suggest = " + namer.suggest("node"));
	System.out.println("suggest = " + namer.suggest("node"));

	UniqueName foo, foo2;
	
	namer.put(foo = new UniqueName("foo"));
	namer.put(foo2 = new UniqueName("foo2"));
	namer.remove(foo);
	System.out.println("namer = " + namer);
	namer.remove(foo2);
	System.out.println("namer = " + namer);
    }
}

/* Expected Output:
suggest = node3
suggest = node4
suggest = node6
suggest = node7
namer = Namer[ht={node=[node1, node2, node3, node4, node5, node6, node7], foo=[foo2]}]
namer = Namer[ht={node=[node1, node2, node3, node4, node5, node6, node7]}]
*/
