
import java.util.Arrays;

import thinlet.ThinletBase;

public class ThinletBaseTest extends ThinletBase {
	public ThinletBaseTest() {
	}

	public void run() {
	}

	protected Object[] getDefinition(Object classname, String key, String type) {
		return null;
	}

	public Object create(String classname) {
		return ThinletBase.createImpl(classname);
	}

	public boolean set(Object component, Object key, Object value) {
		return super.set(component, key, value);
	}

	public static Object get(Object component, Object key) {
		return ThinletBase.get(component, key);
	}

	public int getIndex(Object component, Object value) {
		return super.getIndex(component, value);
	}

	public void insertItem(Object parent, Object component, int index) {
		super.insertItemImpl(parent, ":comp", component, index);
	}

	public static void main(String args[]) throws Throwable {
		ThinletBaseTest tbt = new ThinletBaseTest();

		if (tbt.getDesktop() != null)
			System.out.println("Able to get desktop");
		else
			System.out.println("Unable to get desktop?");
		System.out.println("desktop class: " + ThinletBase.getClass(tbt.getDesktop()));

		Object obj = tbt.create("foo");

		if (!tbt.set(obj, ":bar", "baz"))
			System.out.println("Attribute was not changed?");
		if (!"baz".equals(ThinletBase.get(obj, ":bar")))
			System.out.println("Attribute does not equal baz?");
		if (tbt.getCount(obj) != 0)
			System.out.println("Object has a non-zero item count?");
		if (tbt.getItems(obj).length != 0)
			System.out.println("Object has a non-zero length item list?");
		if (tbt.getParent(obj) != null)
			System.out.println("Object has a parent?");
		if (!tbt.set(obj, ":bar", null))
			System.out.println("Clearing attribute was not a change?");
		if (ThinletBase.get(obj, ":bar") != null)
			System.out.println("Attribute is still set?");

		Object items[], children[];
		int lpc;

		children = new Object[32];
		for (lpc = 0; lpc < children.length; lpc++) {
			children[lpc] = tbt.create("foo" + lpc);
			tbt.set(children[lpc], ":parent", obj);
		}

		for (lpc = 0; lpc < children.length - 1; lpc++) {
			tbt.set(children[lpc], ":next", children[lpc + 1]);
		}

		tbt.set(obj, ":comp", children[0]);

		if (tbt.getCount(obj) != children.length) {
			System.out.println("Object has " + tbt.getCount(obj)
								+ " children, instead of " + children.length);
		}

		for (lpc = 0; lpc < children.length; lpc++) {
			if (tbt.getItem(obj, lpc) != children[lpc]) {
				System.out.println("Item " + lpc + " does not equal child?");
			}
			if (tbt.getParent(children[lpc]) != obj) {
				System.out.println("Child " + lpc + " has the wrong parent?");
			}
		}

		if (!Arrays.equals(tbt.getItems(obj), children))
			System.out.println("Items array does not equal children?");

		for (lpc = 0; lpc < children.length; lpc++) {
			if (tbt.getIndex(obj, children[lpc]) != lpc) {
				System.out.println("Item is at a different index? " + lpc);
			}
		}

		tbt.set(obj, ":comp", null);

		try {
			tbt.insertItem(obj, children[0], 0);
			System.out.println("Able to add attached child?");
		} catch (IllegalArgumentException e) {
		}

		for (lpc = 0; lpc < children.length; lpc++) {
			tbt.set(children[lpc], ":parent", null);
			tbt.insertItem(obj, children[lpc], -1);
		}
		if (!Arrays.equals(tbt.getItems(obj), children))
			System.out.println("Items array does not equal children?");
	}
}

/* Expected Output:
Able to get desktop
desktop class: desktop
*/
