/*
 * UniqueNameTest.java
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

import net.emulab.ns.UniqueName;

public class UniqueNameTest {
	public static void main(String args[]) {
		UniqueName un;

		un = new UniqueName("node");
		System.out.println("un = " + un);
		System.out.println("un = " + un.increment());
		System.out.println("cmp = " + un.compareTo(new UniqueName("node")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node1")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node-1")));

		un = new UniqueName("node0");
		System.out.println("un = " + un);
		System.out.println("un = " + un.increment());
		System.out.println("cmp = " + un.compareTo(new UniqueName("node0")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node00")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node000")));

		un = new UniqueName("node20");
		System.out.println("un = " + un);
		System.out.println("un = " + un.increment());
		System.out.println("cmp = " + un.compareTo(new UniqueName("node")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node1")));
		System.out.println("cmp = " + un.compareTo(new UniqueName("node21")));

		un = new UniqueName("node29");
		System.out.println("un = " + un);
		System.out.println("un = " + un.increment());

		un = new UniqueName("node29v");
		System.out.println("un = " + un);

		un = new UniqueName("reallylongname");
		System.out.println("short = " + un.toShortString(8));
		System.out.println("short = " + un.toShortString(7));
		un = new UniqueName("rln100000000000");
		System.out.println("short = " + un.toShortString(8));
		System.out.println("short = " + un.toShortString(7));
	}
}

/* Expected Output:
un = node
un = node2
cmp = 0
cmp = -2
cmp = -1
un = node0
un = node1
cmp = 0
cmp = -1
cmp = -2
un = node20
un = node21
cmp = 21
cmp = 19
cmp = -1
un = node29
un = node30
un = node29v
short = rea..ame
short = re..ame
short = rln..000
short = rl..000
*/
